Bug 991536 - gnuplot-wx crash/corrupted input with piped input
gnuplot-wx crash/corrupted input with piped input
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: gnuplot (Show other bugs)
18
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Frantisek Kluknavsky
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-08-02 12:49 EDT by John Sullivan
Modified: 2014-02-05 17:13 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-02-05 17:13:38 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description John Sullivan 2013-08-02 12:49:04 EDT
Description of problem:

When used with piped input and -persist gnuplot will crash if the graph is zoomed (by right-click + drag + clicking on the graph window to select a zoom area).


Version-Release number of selected component (if applicable):

Spotted in gnuplot-4.6.1-4.fc18.x86_64, verified in upstream 4.6.1, once I'd already tracked down and fixed the problem myself I see that upstream 4.6.3 contains a fix.

Fedora bug for upgrade to upstream 4.6.3:
https://bugzilla.redhat.com/show_bug.cgi?id=953407

Upstream bug ref:
http://sourceforge.net/p/gnuplot/bugs/1203/

The upstream description is fairly complete so I won't go in-depth here, simply put EOF scribbles on the line buffer without resetting the parser state, so we at some point attempt to continue parse/execution in the middle of garbage input.


How reproducible:

Reliably.


Steps to Reproduce:

Once the graph window is visible, right-click, drag out a zoom rectangle, then click (either button) again to zoom.

Compare the following cases:

gnuplot-wx
gnuplot> plot x

echo "plot x" >/tmp/gnuplot-cmds
gnuplot-wx -persist /tmp/gnuplot-cmds

echo "plot x" | gnuplot-wx -persist

( echo "plot x" ; sleep 3600 ) | gnuplot-wx

In the first two zooming appears to work fine. The second two, under other systems we just get an error printed out and the process terminates (in this case it complains about substr() being given non-integer arguments, with a more complicated plot line it'll probably give some variety of other parse error).

Under Fedora it actually crashes with a stack-smash error.


Additional info:

Once I'd tracked down and fixed the cause of the syntax errors, it then became possible to compare with the latest upstream source and see that it is also fixed there. (Their fix is better.)

I note that 4.6.3 has been taken for fc20, but fc18 and fc19 are still at 4.6.1 - hopefully this crash counts as a push for bug 953407 going to fc18 and fc19 as well to pick up the upstream fix. (Or temporarily backport a fix if not.)

Note that the fix just avoids generating the parse error in this case (which is a real actual bug in itself.) The crash under Fedora is a separate unrelated gnuplot bug which I have raised bug 991534 for.
Comment 1 Fedora End Of Life 2013-12-21 09:25:26 EST
This message is a reminder that Fedora 18 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 18. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '18'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 18's end of life.

Thank you for reporting this issue and we are sorry that we may not be 
able to fix it before Fedora 18 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior to Fedora 18's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 2 Fedora End Of Life 2014-02-05 17:13:38 EST
Fedora 18 changed to end-of-life (EOL) status on 2014-01-14. Fedora 18 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.